"use strict";


function InitEverything() {

	g_pageSwapper.wireupHandlers();
	
	// fileMgr example.
	/*g_genUI.transientMsg("initFS", "Initializing filesystem...");
	if (window.cordova)
		g_fileMgr.cordovaFileRoot = g_isIOS ? cordova.file.documentsDirectory : cordova.file.externalRootDirectory;
	g_fileMgr.initFileSys(function(rootDir) {
		g_genUI.transientMsg("initFS", "Filesys initialized");

	});*/
	
	// State files example.
	g_stateMgr.initStateMgr(function() {
		console.log("StateMgr init'ed");
		
		// Preload files
		// Note: preloading "file1" allows synchronous read later.  (Otherwise asyncronous reads required.)
		g_stateMgr.preloadFiles(["file_1"], function() {
			var file1_contents = g_stateMgr.loadDataSync("file_1");
		});
		// Save and read example. (Files stored as JSON.)
		g_stateMgr.saveDataSync("file_2", "new file2 contents");
		g_stateMgr.loadDataAsync("file_2", function(contents) {
			console.log("file2 contents: " + contents);
		});

		// More init stuff here? ...
	});
	
	// Overlay1 opener
	$("body").on("click", ".jsOverlay1Opener", function() {
		g_pageSwapper.slideInOverlay($(".jsOverlay1Panel"));
	});

	// Nav handler
	$(window).on('hashchange', function() {
		var hashVal = location.hash;
		if (hashVal == "#" || hashVal == "#home") { // special case nave to home.
			g_pageSwapper.hideAllOverlays();
			return;
		}
		if (hashVal.indexOf("#pages/") === 0) {
			var srcUrl = hashVal.replace("#", "");
			g_pageSwapper.swapToFrame(srcUrl);
		}
	});
	//window.location.hash = "#";
	$(window).trigger("hashchange");
	
	// Homebrew transient msg (imitating native Android UI) example.
	$(".jsTransientMsgDemo").on("click", function() {
		g_genUI.transientMsg("msgId1", "This is a transient message.");
	});

	// Native Android/iOS dialog box example.
	$(".jsNativeAlertDemo").on("click", function() {
		g_genUI.alertMsg("This is a native alert box.", "Dialog Title Here", function() {
			console.log("Native dialog was closed.");
		});
	});
	
}


// App startup
//------------
var g_isIOS = navigator.userAgent.match(/iPhone|iPad|iPod/i);
var g_genUI = new utilGenUI();
//var g_fileMgr = new utilFileMgr();
var g_stateMgr = new utilStateFilesMgr("statefiles");
var g_pageSwapper = new utilPageSwapper();


// Auto-wire-up:
window.addEventListener('load', function() {

	// Init everything.
	if (!window.cordova) {
		setTimeout(function() { InitEverything(); }, 1000);
	}
	else {
		document.addEventListener("deviceready", function() { InitEverything(); }, false);
	}

});
