"use strict";

// Simple class for persisting state with html5 localstorage
// - Subject to browser/environment localstorage limits (~10MB)
// - Values converted to JSON for storage, so values limited accordingly.
function utilAppState() {
	this.test = "";
}

utilAppState._LoadedVals = {};

utilAppState.LoadVal = function(varname) {
	var output;
	// Try to load from cache (ram).
	if (varname in utilAppState._LoadedVals) {
		output = utilAppState._LoadedVals[varname];
	}
	else {
		output = localStorage.getItem(varname);
		// If varname DNE, getItem() (and LoadVal()) return null.
		if (output !== null) {
			output = JSON.parse(output);
		}
		// Cache in ram.
		utilAppState._LoadedVals[varname] = output;
	}
	return output;
}
utilAppState.SaveVal = function(varname, value) {
	localStorage.setItem(varname, JSON.stringify(value));
	//LogDebug("Saved data - " + varname);
	// Cache in ram.
	utilAppState._LoadedVals[varname] = value;
}
utilAppState.ValExists = function(varname) {
	return utilAppState.LoadVal(varname) !== null;
}

