"use strict";

function utilPageSwapper() {
	this.test = "";
	
}


utilPageSwapper.prototype.wireupHandlers = function() {
	var self = this;
	
	// KitKat doesn't seem to recognize "translateX(101%)" in main.css, so jsOverlay_frameB sits floating over main screen on startup.  Procedurally move overlays off-screen on startup here.
	$(".screenOverlay").css("transition-property", "top, left, opacity, transform");
	$(".screenOverlay").css("transition-duration", "0");
	$(".screenOverlay").css("transform", "translate3d(0, 201%, 0)");
	$(".screenOverlay").css("opacity", "0");
	
}


// Show/Hide overlay:
utilPageSwapper.prototype.slideInOverlay = function($overlay, callback) {
	if (!$overlay.hasClass("screenOverlay")) {
		alert("Error: slideInOverlay on non-screenOverlay class.");
		return;
	}

	// z-index: current=11; inactive=10; currentlyAnimating=12;
	$overlay.css("z-index", "12");
	$overlay.css("transition-property", "top, left, opacity, transform");
	$overlay.css("transition-duration", "0s");
	$overlay.css("transform", "translate3d(0, 32%, 0)");
	$overlay.css("opacity", "0.01");

	setTimeout(function() { // give overlay a chance to snap to 32%.
		$overlay.css("transition-duration", "0.4s");
		$overlay.css("transform", "translate3d(0, 0, 0)");
		$overlay.css("opacity", "1");
		setTimeout(function() {
			$('.main1Panel').empty(); // Clear legacy main1Panel contents.
			$(".screenOverlay").css("z-index", "10"); // all overlays (even current) to 10;
			$overlay.css("z-index", "11"); // current to 11;
			if (callback)
				callback();
		}, 400);
	}, 50);
}
utilPageSwapper.prototype.hideAllOverlays = function(callback) {
	$(".jsAppHomePanel .clicked").removeClass("clicked");
	$(".screenOverlay").css("transition-property", "top, left, opacity, transform");
	$(".screenOverlay").css("transition-duration", "0.4s");
	$(".screenOverlay").css("transform", "translate3d(0, 67%, 0)");
	$(".screenOverlay").css("opacity", "0"); // Hide everything else.
	setTimeout(function() {
		$(".screenOverlay").css("transition-duration", "0s");
		$(".screenOverlay").css("transform", "translate3d(0, 201%, 0)");
		if (callback)
			callback();
	}, 400);
}


utilPageSwapper.prototype.swapToFrame = function(srcUrl) {
	// Swap out A & B frame (2 frames so window can frame-to-frame nav looks natural.)
	this.currentFrame = this.currentFrame == "A" ? "B" : "A";
	var $overlay = this.currentFrame == "A" ? $(".jsOverlay_frameA") : $(".jsOverlay_frameB");
	// Set active frame indicator.
	$(".jsScreenOverlay").not($overlay).removeClass("isActive");
	$overlay.addClass("isActive");
	
	// Load frame and slide in overlay.
	//this.loadFrameInOverlay(srcUrl, $overlay);
	var $frameContainer = $overlay.find(".jsFrameContainer");
	if (!$frameContainer.length)
		throw "No frameContainer found."
	var iframeEl = this.getLoadedFrameEl(srcUrl);
	$frameContainer.empty();
	$frameContainer.append(iframeEl);
	this.slideInOverlay($overlay, function() { });
}


utilPageSwapper.prototype.getLoadedFrameEl = function(srcUrl) {
	var iframeEl = document.createElement('iframe');
	// Append timestamp to force reload of iframe content.
	var appendTS = (srcUrl.indexOf('?') > -1 ? "&" : "?") + 'ts=' + Date.now();
	iframeEl.src = srcUrl + appendTS;

	// iOS iframe scrolling fix.  (Without this, whole iframe scrolls x-y as 1, not recognizing individual e.g. x-scrolling divs.)
	// - Note: on not-iOS, these attributes cause iframe contents to not scroll at all, requiring jsHeightToFull+scrollableDiv for page scroll.  Alternative: don't apply to non-iOS.
	if (g_isIOS) {
		iframeEl.scrolling = "no";				// iOS scrolling fix - http://stackoverflow.com/a/35467165
		$(iframeEl).css("width", "1px");		// ditto
		$(iframeEl).css("min-width", "100%");	// ditto
	}
	
	return iframeEl;
}

